// WSLにおいてシステムコールの実装状況を調べるプログラム

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/wait.h>
#include <sys/types.h>
#include <errno.h>


#define NUM_OF_SYSCALLS	333

int main(int argc, char** argv)
{
	int syscall_num = 0;

	for( syscall_num=0; syscall_num < NUM_OF_SYSCALLS; syscall_num++)
	{
		// プロセスをforkする.
		int pid = fork();

		if ( pid == 0 )
		{
			// 子プロセスの場合はシステムコールを呼ぶ.

			if ( syscall_num == 34 )
			{
				// pauseシステムコールの場合は省略する.
				printf("[%d] is SKIPPED.\n", syscall_num);
				exit(0);
			}
			else if ( syscall_num == 57 )
			{
				// forkシステムコールの場合は省略する.
				printf("[%d] is SKIPPED.\n", syscall_num);
				exit(0);
			}
			else if ( syscall_num == 58 )
			{
				// vforkシステムコールの場合は省略する.
				printf("[%d] is SKIPPED.\n", syscall_num);
				exit(0);
			}
			else if ( syscall_num == 231 )
			{
				// exitgroupシステムコールの場合は省略する.
				printf("[%d] is SKIPPED.\n", syscall_num);
				exit(0);
			}
			else if ( syscall_num == 302 )
			{
				// prlimit64システムコールの場合は省略する.
				printf("[%d] is SKIPPED.\n", syscall_num);
				exit(0);
			}


			// システムコール呼び出し
			syscall(syscall_num);
			if ( errno == ENOSYS)
			{
				printf("[%d] is NOT implemented (ENOSYS).\n", syscall_num);
			}
			else
			{
				printf("[%d] is implemented.\n", syscall_num );
			}
			exit(0);
		}
		else
		{
			// 親プロセスの場合は子プロセスの終了を待つ.
			int status;
			waitpid(pid, &status, 0);
		}
		
	}

}